diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
index 528e97afb..20777f0b1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFireStriker.java
@@ -31,7 +31,7 @@ public class ItemFireStriker extends Item {
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         blockPos = blockPos.add(side.getDirection(), new TilePos());
         if (world.isAirBlock(blockPos)) {
-            if (world.setBlockIdNotify(blockPos, Blocks.FIRE.id())) {
+            if (world.setBlockTypeNotify(blockPos, Blocks.FIRE)) {
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) blockPos.x() + 0.5D, (double) blockPos.y() + 0.5D, (double) blockPos.z() + 0.5D, "fire.ignite", 1.0F, itemRand.nextFloat() * 0.4F + 0.8F);
                 selfStack.damageItem(1, player);
                 return true;
@@ -46,15 +46,15 @@ public class ItemFireStriker extends Item {
         if (!onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5)) {
             blockPos = blockPos.add(direction, new TilePos());
             TilePos queryPos = new TilePos();
-            Block<?> b = world.getBlock(blockPos);
+            Block<?> b = world.getBlockType(blockPos);
             if (Block.getLogicClass(b) instanceof BlockLogicBrazier brazier && brazier.isBurning()) {
-                if (Block.hasLogicClass(world.getBlock(blockPos.east(queryPos)), BlockLogicFluid.class) ||
-                    Block.hasLogicClass(world.getBlock(blockPos.west(queryPos)), BlockLogicFluid.class) ||
-                    Block.hasLogicClass(world.getBlock(blockPos.south(queryPos)), BlockLogicFluid.class) ||
-                    Block.hasLogicClass(world.getBlock(blockPos.north(queryPos)), BlockLogicFluid.class)) {
+                if (Block.hasLogicClass(world.getBlockType(blockPos.east(queryPos)), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlockType(blockPos.west(queryPos)), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlockType(blockPos.south(queryPos)), BlockLogicFluid.class) ||
+                    Block.hasLogicClass(world.getBlockType(blockPos.north(queryPos)), BlockLogicFluid.class)) {
                     return;
                 }
-                world.setBlockIdDataNotify(blockPos, Blocks.BRAZIER_ACTIVE.id(), 0);
+                world.setBlockTypeNotify(blockPos, Blocks.BRAZIER_ACTIVE);
                 selfStack.damageItem(1, null);
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) blockPos.x() + 0.5D, (double) blockPos.y() + 0.5D, (double) blockPos.z() + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
             } else if (Block.getLogicClass(b) instanceof BlockLogicTNT tnt) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
index 1289b5f73..fb4726bc3 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -33,7 +33,7 @@ public class ItemFlag extends Item {
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         // copy flag data to empty flag
-        if (world.getBlockId(blockPos) == Blocks.FLAG.id() && player != null && !player.isSneaking()) {
+        if (world.getBlockType(blockPos) == Blocks.FLAG && player != null && !player.isSneaking()) {
             if (world.getTileEntity(blockPos) instanceof TileEntityFlag flag) {
                 CompoundTag flagData = selfStack.getData().getCompoundOrDefault("FlagData", new CompoundTag());
                 if (hasFlagBeenDrawnOn(selfStack) && doesFlagContainDyes(selfStack)) {
@@ -67,7 +67,7 @@ public class ItemFlag extends Item {
         }
 
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.FLAG, EnumBlockSoundEffectType.PLACE);
-        world.setBlockIdDataNotify(blockPos, Blocks.FLAG.id(), 0);
+        world.setBlockTypeNotify(blockPos, Blocks.FLAG);
 
         selfStack.consumeItem(player);
         if (world.getTileEntity(blockPos) instanceof TileEntityFlag flag) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
index 1b00dd329..11b149740 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -126,7 +126,7 @@ public class ItemMap extends Item implements IComplexItem
 
 	@Override
 	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-		if (world.getBlockId(blockPos) == Blocks.FLAG.id()) {
+		if (world.getBlockType(blockPos) == Blocks.FLAG) {
 			if (hasInitialized(selfStack)) {
 				for (byte scale = 0; scale <= ItemMapSavedData.MAX_SCALE; scale++) {
 					ItemMapSavedData mapData = getOrCreateSavedData((short) selfStack.getMetadata(), scale, world);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
index 971180231..ffa78f320 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
@@ -27,7 +27,7 @@ public class ItemMinecart extends Item {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        Block<?> block = world.getBlock(blockPos);
+        Block<?> block = world.getBlockType(blockPos);
         if (!Block.hasLogicClass(block, BlockLogicRail.class)) { return false; }
 
         if(!world.isClientSide) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index 881ceeb67..8b969fc60 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -38,8 +38,7 @@ public class ItemPaintBrush extends Item {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        final int id = world.getBlockId(blockPos);
-        final Block<?> block = Blocks.getBlock(id);
+        final Block<?> block = world.getBlockType(blockPos);
 
         if (Block.hasLogicClass(block, BlockLogicSign.class) && world.getTileEntity(blockPos) instanceof TileEntitySign sign && (player != null && player.isSneaking())) {
             final DyeColor color = getColor(selfStack);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index e66293138..89bb4b95e 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.tag.BlockTags;
@@ -38,10 +39,10 @@ public class ItemPebble extends Item implements IDispensable {
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (player == null) return false;
-        int id = world.getBlockId(blockPos);
+        @NotNull Block<?> block = world.getBlockType(blockPos);
         int meta = world.getBlockData(blockPos);
-        if (id != Blocks.OVERLAY_PEBBLES.id() && Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES)) {
-            id = 0;
+        if (block != Blocks.OVERLAY_PEBBLES && block.hasTag(BlockTags.PLACE_OVERWRITES)) {
+            block = Blocks.AIR;
             meta = 0;
         }
         if (selfStack.stackSize <= 0) {
@@ -52,31 +53,29 @@ public class ItemPebble extends Item implements IDispensable {
         }
 
         // Check if we're placing "inside" a layer
-        if (id == Blocks.OVERLAY_PEBBLES.id() && side == Side.TOP) {
+        if (block == Blocks.OVERLAY_PEBBLES && side == Side.TOP) {
             final int newMeta = meta + 1;
             if (!world.canPlaceOnSurfaceOfBlock(blockPos.down(new TilePos()))) {
                 return false;
             }
 
             if (newMeta < 3) {
-                world.setBlockIdDataNotify(blockPos, Blocks.OVERLAY_PEBBLES.id(), newMeta);
+                world.setBlockTypeDataNotify(blockPos, Blocks.OVERLAY_PEBBLES, newMeta);
                 world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
             }
-
-
         }
 
         // Offset position
-        if (id != 0) {
+        if (block != Blocks.AIR) {
             blockPos = blockPos.add(side.getDirection(), new TilePos());
-            id = world.getBlockId(blockPos);
+            block = world.getBlockType(blockPos);
             meta = world.getBlockData(blockPos);
         }
 
         // Check if the block we're placing into is a layer
-        if (id == Blocks.OVERLAY_PEBBLES.id()) {
+        if (block == Blocks.OVERLAY_PEBBLES) {
             final int newMeta = meta + 1;
 
             final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
@@ -85,7 +84,7 @@ public class ItemPebble extends Item implements IDispensable {
             }
 
             if (newMeta < 3) {
-                world.setBlockIdDataNotify(blockPos, Blocks.OVERLAY_PEBBLES.id(), newMeta);
+                world.setBlockTypeDataNotify(blockPos, Blocks.OVERLAY_PEBBLES, newMeta);
                 world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
@@ -95,7 +94,7 @@ public class ItemPebble extends Item implements IDispensable {
 
         // Regular placement, as all else fails
         if (world.canBlockIdBePlacedAt(Blocks.OVERLAY_PEBBLES.id(), blockPos, false, side) && world.canPlaceOnSurfaceOfBlock(blockPos.down(new TilePos()))) {
-            if (world.setBlockIdDataNotify(blockPos, Blocks.OVERLAY_PEBBLES.id(), 0)) {
+            if (world.setBlockTypeNotify(blockPos, Blocks.OVERLAY_PEBBLES)) {
                 Blocks.OVERLAY_PEBBLES.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
                 world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
index 212e44032..bc5ba2bdb 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
@@ -38,7 +38,7 @@ public class ItemPlaceable extends Item {
             return false;
         }
         if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
-            if (world.setBlockIdNotify(blockPos, this.blockToPlace.id())) {
+            if (world.setBlockTypeNotify(blockPos, this.blockToPlace)) {
                 if (player == null) {
                     this.blockToPlace.onPlacedOnSide(world, blockPos, side, xHit, yHit);
                 } else {
@@ -60,7 +60,7 @@ public class ItemPlaceable extends Item {
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         blockPos = blockPos.add(direction, new TilePos());
-        Block<?> b = world.getBlock(blockPos);
+        Block<?> b = world.getBlockType(blockPos);
         if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
             onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
index 083e383ca..bed21556f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -23,7 +23,7 @@ public class ItemRope extends ItemPlaceable {
         }
         TilePos bp = new TilePos(blockPos);
         boolean placeOnSide = true;
-        if (world.getBlock(bp) == this.blockToPlace && player != null && !player.isSneaking()) {
+        if (world.getBlockType(bp) == this.blockToPlace && player != null && !player.isSneaking()) {
             placeOnSide = false;
             TilePos tempPos = new TilePos(bp);
             int _y = bp.y;
@@ -32,7 +32,7 @@ public class ItemRope extends ItemPlaceable {
                 if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), tempPos.set(bp.x, _y, bp.z), false, side)) {
                     bp.y = _y;
                     break;
-                } else if (world.getBlock(tempPos.sub(bp.x, _y, bp.z, new TilePos())) != this.blockToPlace) {
+                } else if (world.getBlockType(tempPos.sub(bp.x, _y, bp.z, new TilePos())) != this.blockToPlace) {
                     if (side == Side.TOP) {
                         break;
                     }
@@ -48,7 +48,7 @@ public class ItemRope extends ItemPlaceable {
             return false;
         }
         if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), bp, false, side) && selfStack.consumeItem(player)) {
-            if (world.setBlockIdDataNotify(bp, this.blockToPlace.id(), placeOnSide ? BlockLogicRope.MASK_ROPE_CONNECT : 0)) {
+            if (world.setBlockTypeDataNotify(bp, this.blockToPlace, placeOnSide ? BlockLogicRope.MASK_ROPE_CONNECT : 0)) {
                 if (player == null) {
                     this.blockToPlace.onPlacedOnSide(world, bp, side, xHit, yHit);
                 } else {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
index a9018839a..37e8518f8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
@@ -31,8 +31,8 @@ public class ItemSeeds extends Item {
         if (!world.canPlaceInsideBlock(blockPos)) {
             blockPos = blockPos.add(side.getDirection(), new TilePos());
         }
-        if (world.getBlockId(blockPos.down(new TilePos())) == Blocks.FARMLAND_DIRT.id() && world.canPlaceInsideBlock(blockPos)) {
-            if (world.setBlockIdNotify(blockPos, this.cropsBlock.id())) {
+        if (world.getBlockType(blockPos.down(new TilePos())) == Blocks.FARMLAND_DIRT && world.canPlaceInsideBlock(blockPos)) {
+            if (world.setBlockTypeNotify(blockPos, this.cropsBlock)) {
                 world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.cropsBlock, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
@@ -44,7 +44,7 @@ public class ItemSeeds extends Item {
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         blockPos = blockPos.add(direction, new TilePos());
-        Block<?> b = world.getBlock(blockPos);
+        Block<?> b = world.getBlockType(blockPos);
         boolean isFarmland = Block.hasLogicClass(b, BlockLogicFarmland.class);
         if (b == null || isFarmland || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
             onUseOnBlock(selfStack, world, null, blockPos.add(0, isFarmland ? 1 : 0, 0, new TilePos()), direction.getSide(), 0.5, 0.5);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
index 4ccbb112d..36a62aa52 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -35,10 +35,10 @@ public class ItemSign extends Item {
 
         if (side == Side.TOP) {
             world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_POST_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
-            world.setBlockIdDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK.id(), MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+            world.setBlockTypeDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
         } else {
             world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
-            world.setBlockIdDataNotify(blockPos, Blocks.SIGN_WALL_PLANKS_OAK.id(), side.getId());
+            world.setBlockTypeDataNotify(blockPos, Blocks.SIGN_WALL_PLANKS_OAK, side.getId());
         }
         selfStack.consumeItem(player);
         if (world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
index 8b5907dd1..a431013e7 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
@@ -35,10 +35,10 @@ public class ItemSignPainted extends ItemSign {
         if (side == Side.TOP) {
             int direction = MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf;
             world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_POST_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
-            world.setBlockIdDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.id(), Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | direction);
+            world.setBlockTypeDataNotify(blockPos, Blocks.SIGN_POST_PLANKS_OAK_PAINTED, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | direction);
         } else {
             world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED, EnumBlockSoundEffectType.PLACE);
-            world.setBlockIdDataNotify(blockPos, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED.id(), Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | side.getId());
+            world.setBlockTypeDataNotify(blockPos, Blocks.SIGN_WALL_PLANKS_OAK_PAINTED, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | side.getId());
         }
         selfStack.consumeItem(player);
         if (world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index 3f421b05d..94adda0c5 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -13,6 +13,7 @@ import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.conversion.ChunkConverter;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -119,9 +120,10 @@ public final class ItemStack {
 
     @Deprecated
     public boolean useItem(@NotNull Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xHit, double yHit) {
-        return useItemOnBlock(player, world, new TilePos(blockX, blockY, blockZ), side, xHit, yHit);
+        return this.useItemOnBlock(player, world, new TilePos(blockX, blockY, blockZ), side, xHit, yHit);
     }
-    public boolean useItemOnBlock(@NotNull Player player, @NotNull World world, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+
+    public boolean useItemOnBlock(@NotNull Player player, @NotNull World world, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if(getItem().onUseOnBlock(this, world, player, blockPos, side, xHit, yHit)) {
             player.addStat(getItem().getStat(StatList.STAT_USED), 1);
             return true;
@@ -135,7 +137,7 @@ public final class ItemStack {
 
     @Deprecated
     public @Nullable ItemStack useItemRightClick(@NotNull World world, @NotNull Player entityplayer) {
-        return getItem().onUseItem(this, world, entityplayer);
+        return this.useItem(world, entityplayer);
     }
 
     public @Nullable ItemStack useItem(@NotNull World world, @NotNull Player player) {
@@ -287,23 +289,19 @@ public final class ItemStack {
 
     @Deprecated
     public boolean beforeDestroyBlock(@NotNull World world, int id, int x, int y, int z, @NotNull Side side, @NotNull Player player) {
-    	return getItem().beforeDestroyBlock(world, this, id, x, y, z, side, player);
+    	return this.beforeBlockDestroyed(world, player, Objects.requireNonNull(Blocks.getBlock(id)), new TilePos(x, y, z), side);
     }
 
-    public boolean beforeBlockDestroyed(@NotNull World world, @NotNull Player player, @NotNull Block<?> block, @NotNull TilePos blockPos, @NotNull Side side) {
+    public boolean beforeBlockDestroyed(final @NotNull World world, final @NotNull Player player, final @NotNull Block<?> block, final @NotNull TilePosc blockPos, final @NotNull Side side) {
         return getItem().beforeBlockDestroyed(this, world, player, block, blockPos, side);
     }
 
     @Deprecated
     public void onDestroyBlock(@NotNull World world, int id, int x, int y, int z, @NotNull Side side, @NotNull Player entityplayer) {
-        boolean flag = getItem().onBlockDestroyed(world, this, id, x, y, z, side, entityplayer);
-        if(flag)
-        {
-            entityplayer.addStat(getItem().getStat(StatList.STAT_USED), 1);
-        }
+        this.onBlockDestroyed(world, entityplayer, Objects.requireNonNull(Blocks.getBlock(id)), new TilePos(x, y, z), side);
     }
 
-    public void onBlockDestroyed(final @NotNull World world, final @NotNull Player player, final @NotNull Block<?> removedBlock, final @NotNull TilePos blockPos, final @NotNull Side side) {
+    public void onBlockDestroyed(final @NotNull World world, final @NotNull Player player, final @NotNull Block<?> removedBlock, final @NotNull TilePosc blockPos, final @NotNull Side side) {
         if (getItem().onBlockDestroyed(this, world, player, removedBlock, blockPos, side)) {
             player.addStat(getItem().getStat(StatList.STAT_USED), 1);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
index 4e60566c0..accb5a936 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
@@ -36,11 +36,11 @@ public class ItemStatue extends Item {
         }
 
         world.noNeighborUpdate = true;
-        world.setBlockIdDataNotify(blockPos, this.statueBlockBottom.id(), MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
-        world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.statueBlockTop.id(), MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+        world.setBlockTypeDataNotify(blockPos, this.statueBlockBottom, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
+        world.setBlockTypeDataNotify(blockPos.up(new TilePos()), this.statueBlockTop, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
         world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom.id());
-        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.statueBlockTop.id());
+        world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom);
+        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.statueBlockTop);
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
         this.statueBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         this.statueBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
@@ -58,11 +58,11 @@ public class ItemStatue extends Item {
         }
 
         world.noNeighborUpdate = true;
-        world.setBlockIdNotify(blockPos, this.statueBlockBottom.id());
-        world.setBlockIdNotify(blockPos.up(new TilePos()), this.statueBlockTop.id());
+        world.setBlockTypeNotify(blockPos, this.statueBlockBottom);
+        world.setBlockTypeNotify(blockPos.up(new TilePos()), this.statueBlockTop);
         world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom.id());
-        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.statueBlockTop.id());
+        world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom);
+        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.statueBlockTop);
         world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
         this.statueBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
         this.statueBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.getSide(), 0.5, 0.5);
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index 3f7f54fa6..18351c234 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -45,7 +45,7 @@ public class ItemBlock<T extends BlockLogic> extends Item {
         }
         if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
             int meta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-            if (world.setBlockIdDataNotify(blockPos, this.block.id(), meta)) {
+            if (world.setBlockTypeDataNotify(blockPos, this.block, meta)) {
                 if (player == null) {
                     this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
                 } else {
@@ -69,7 +69,7 @@ public class ItemBlock<T extends BlockLogic> extends Item {
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         blockPos = blockPos.add(direction, new TilePos());
-        Block<?> b = world.getBlock(blockPos);
+        Block<?> b = world.getBlockType(blockPos);
         if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
             onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
index 4fc96cded..8694aaf19 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
@@ -41,16 +41,16 @@ public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T> {
         }
         if (rayCast instanceof HitResult.Tile hitTile) {
             TilePos blockPos = new TilePos(hitTile.tilePos);
-            if (world.getBlockId(blockPos) == Blocks.FLUID_WATER_STILL.id()) {
+            if (world.getBlockType(blockPos) == Blocks.FLUID_WATER_STILL) {
                 blockPos.y++;
             } else {
                 return selfStack;
             }
 
-            if (world.getBlockId(blockPos) != 0) {
+            if (world.getBlockType(blockPos) != Blocks.AIR) {
                 return selfStack;
             }
-            if (selfStack.consumeItem(player) && world.setBlockIdDataNotify(blockPos, this.block.id(), 0)) {
+            if (selfStack.consumeItem(player) && world.setBlockTypeNotify(blockPos, this.block)) {
                 this.block.onPlacedByMob(world, blockPos, Side.NONE, player, 0.5, 0.5);
                 world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
                 player.swingItem();
@@ -63,10 +63,10 @@ public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T> {
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         blockPos = blockPos.add(direction, new TilePos());
         TilePos up = blockPos.up(new TilePos());
-        Block<?> b = world.getBlock(blockPos);
-        Block<?> bAbove = world.getBlock(up);
+        Block<?> b = world.getBlockType(blockPos);
+        Block<?> bAbove = world.getBlockType(up);
         if (b == Blocks.FLUID_WATER_STILL && (bAbove == null || bAbove.hasTag(BlockTags.PLACE_OVERWRITES))) {
-            world.setBlockIdNotify(up, this.block.id());
+            world.setBlockTypeNotify(up, this.block);
             this.block.onPlacedOnSide(world, up, Side.NONE, 0.5, 0.5);
         }
     }
